Update TODO.
[nbdkit/ericb.git] / tests / test-retry-reopen-fail.sh
blobe9ec6e4221c4a05aef6ad23f40b1ac6deb74baca
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright (C) 2018-2019 Red Hat Inc.
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 # This test is similar to test-retry.sh but it also tests the case
34 # where the reopen operation fails.
36 source ./functions.sh
37 set -e
38 set -x
40 fail=0
42 requires qemu-io --version
44 files="retry-reopen-fail-count retry-reopen-fail-open-count
45 retry-reopen-fail-status"
46 rm -f $files
47 cleanup_fn rm -f $files
49 # do_test retries mintime expcount status
50 do_test ()
52 retries=$1
53 mintime=$2
54 expcount=$3
55 status=$4
57 echo 0 > retry-reopen-fail-count
58 echo 0 > retry-reopen-fail-open-count
59 : > retry-reopen-fail-status
60 start_t=$SECONDS
62 # Create a custom plugin which will test retrying.
63 nbdkit -v -U - \
64 sh - \
65 --filter=retry retry-delay=1 retries=$retries \
66 --run 'qemu-io -r -f raw $nbd -c "r 0 512" -c "r 0 512"
67 echo $? >> retry-reopen-fail-status' <<'EOF'
68 #!/usr/bin/env bash
69 handle=$2
70 check_handle () {
71 if [ x"$handle" != xhandle ]; then
72 echo 22 >> retry-reopen-fail-status
73 exit 22
76 case "$1" in
77 open)
78 # Count how many times the connection is (re-)opened.
79 read i < retry-reopen-fail-open-count
80 ((i++))
81 echo $i > retry-reopen-fail-open-count
82 if [ $i -eq 2 ]; then
83 echo "EIO open failed" >&2
84 exit 1
86 echo "handle"
88 pread)
89 check_handle
90 # Fail 2 times then succeed.
91 read i < retry-reopen-fail-count
92 ((i++))
93 echo $i > retry-reopen-fail-count
94 if [ $i -le 2 ]; then
95 echo "EIO pread failed" >&2
96 exit 1
97 else
98 dd if=/dev/zero count=$3 iflag=count_bytes
102 get_size)
103 check_handle
104 echo 512 ;;
105 *) exit 2 ;;
106 esac
109 # Check that running time appears reasonable.
110 end_t=$SECONDS
111 if [ $((end_t - start_t)) -lt $mintime ]; then
112 echo "$0: test ran too quickly"
113 fail=1
116 # Check the handle was opened as often as expected.
117 read open_count < retry-reopen-fail-open-count
118 if [ $open_count -ne $expcount ]; then
119 echo "$0: open-count ($open_count) != $expcount"
120 fail=1
123 # Check the exit status of qemu-io
124 read qemu_status < retry-reopen-fail-status
125 if [ $qemu_status -ne $status ]; then
126 echo "$0: status ($qemu_status) != $status"
127 fail=1
131 # In this first test we should see 3 failures:
132 # first pread FAILS
133 # retry and wait 1 seconds
134 # open FAILS
135 # retry and wait 2 seconds
136 # open succeeds
137 # first pread FAILS
138 # retry and wait 4 seconds
139 # open succeeds
140 # first pread succeeds
141 # second pread succeeds
143 # The minimum time for the test should be 1+2+4 = 7 seconds.
144 do_test 5 7 4 0
146 # In this second test we should see the following:
147 # first pread FAILS
148 # retry and wait 1 seconds
149 # open FAILS, ending first pread in failure
150 # first pread FAILS
151 # second pread requires open
152 # open succeeds
153 # second pread FAILS
154 # retry and wait 1 seconds
155 # open succeeds
156 # second pread succeeds
158 # The minimum time for the test should be 1+1 = 2 seconds.
159 do_test 1 2 3 1
161 exit $fail